//----------------------------------------------------------------------------
//	HEADER:	Config.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Curling game configuration structures
//----------------------------------------------------------------------------

#ifndef TEA_CONFIG_H
#define TEA_CONFIG_H
#ifdef TEA_DEBUG_INCLUDES
#pragma message("#include " __FILE__)
#endif

struct Configuration
{
	// Data members
	struct Player
	{
		char name[16];
		int handicap;
		bool human;
		bool expert;
		real skill;
		real accuracy;
		real tactics;
		real strategy;
		void set(char a_name[16], bool a_human, bool a_expert, real a_skill, real a_precise)
		{
			TEA::System::asciizCopy(name, a_name, dimof(name));
			handicap = 0;
			human = a_human;
			expert = a_expert;
			skill = a_skill;
			accuracy = tactics = strategy = a_precise;
		}
	}
	player[2];
	struct Game
	{
		int stones;
		int ends;
		int guards;
		bool random_ice;
	}
	game;
	bool sound;
	bool quick;

	// Debugging
	bool isValid(void) const
	{
		return TEA::Memory::isValidRead(this);
	}
};

#endif
