//----------------------------------------------------------------------------
//	HEADER:	Rink.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Curling rink model
//----------------------------------------------------------------------------

#ifndef TEA_RINK_H
#define TEA_RINK_H
#ifdef TEA_DEBUG_INCLUDES
#pragma message("#include " __FILE__)
#endif

class Rink
{
	public:

		// Types
		typedef unsigned char Data;
		typedef unsigned int Index;
		enum What
		{
			Hoardings = 0,
			Ice
		};
		struct Model
		{
			Index vertexOffset;
			Index vertexCount;
		};

	private:

		// Data members
		int m_phase;
		const Data* m_ptr;
		const Data* m_end;
		static const Index m_vertices;

	public:

		// Construction
		Rink(void) { reset(); }

		// Vertex iterator
		void reset(void);
		bool next(real xyz[3], real uv[2]);
		static int vertices(void) { return m_vertices; }

		// Index provider
		static void getModel(What what, Model& model);
};

#endif
