//----------------------------------------------------------------------------
//	HEADER:	Sound.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Curling game sound interface
//----------------------------------------------------------------------------

#ifndef TEA_SOUND_H
#define TEA_SOUND_H
#ifdef TEA_DEBUG_INCLUDES
#pragma message("#include " __FILE__)
#endif

class Sound
{
	private:

		// Private data
		bool m_active;
		int m_speed;

	public:

		// Initialisation/shutdown
		bool initialise(void);
		void shutdown(void);

		// Methods
		bool speed(int speed);
		bool bell(int semitones);
		bool orchestra(void);
		bool knock(int speed);

		// Properties
		bool isActive(void) const { return m_active; }

		// Debugging
		bool isValid(void) const
		{
			return TEA::Memory::isValidRead(this) && (m_speed >= 0) && (m_speed <= 127);
		}
};

#endif
