//----------------------------------------------------------------------------
//	HEADER:	Stone.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Curling stone model
//----------------------------------------------------------------------------

#ifndef TEA_STONE_H
#define TEA_STONE_H
#ifdef TEA_DEBUG_INCLUDES
#pragma message("#include " __FILE__)
#endif

class Stone
{
	public:

		// Types
		typedef unsigned char Data;
		typedef unsigned short Index;
		enum What
		{
			Shadow = 0,
			RedStone,
			YellowStone
		};
		struct Colour
		{
			Data b;
			Data g;
			Data r;
			Data a;
		};
		struct Model
		{
			Index vertexOffset;
			Index vertexCount;
			Index* indexArray;
			Index indexCount;
		};

	private:

		// Data members
		int m_phase;
		Index m_count;
		const Data* m_ptr;
		const Data* m_end;
		Colour m_rgba;
		Colour m_base;
		static const Index m_vertices;

		// Implementation
		static void fillModel(Model& model, Index offset, Index* array, Index count, const Data* data);

	public:

		// Construction
		Stone(void) { reset(); }

		// Vertex iterator
		void reset(void);
		bool next(real xyz[3], real normal[3], Colour& rgba);
		static int vertices(void) { return m_vertices; }

		// Index provider
		static void getModel(What what, Model& model);
};

#endif
